Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions

# CollisionHandlerEvent Class Reference

A specialized kind of CollisionHandler that throws an event for each collision detected. More...

Inheritance diagram for CollisionHandlerEvent:

List of all members.

## Public Member Functions
| CollisionHandlerEvent ()
| The default CollisionHandlerEvent will throw no events.
| addAgainPattern (string again_pattern)
| Adds the pattern string that indicates how the event names are generated when a collision between two particular nodes is *still* detected.
| addInPattern (string in_pattern)
| Adds a pattern string to the list of events that will be generated in response to a collision.
| addOutPattern (string out_pattern)
| Adds the pattern string that indicates how the event names are generated when a collision between two particular nodes is *no longer* detected.
| clear ()
| Empties the list of elements that all colliders are known to be colliding with.
| clearAgainPatterns ()
| Removes all of the previously-added in patterns.
| clearInPatterns ()
| Removes all of the previously-added in patterns.
| clearOutPatterns ()
| Removes all of the previously-added in patterns.
| flush ()
| Same as clear() except "out" events are thrown.
string | getAgainPattern (int n)
| Returns the nth pattern string that indicates how the event names are generated for each collision detected.
list | getAgainPatterns ()
string | getInPattern (int n)
| Returns the nth pattern string that indicates how the event names are generated for each collision detected.
list | getInPatterns ()
int | getNumAgainPatterns ()
| Returns the number of in pattern strings that have been added.
int | getNumInPatterns ()
| Returns the number of in pattern strings that have been added.
int | getNumOutPatterns ()
| Returns the number of in pattern strings that have been added.
string | getOutPattern (int n)
| Returns the nth pattern string that indicates how the event names are generated for each collision detected.
list | getOutPatterns ()
| setAgainPattern (string again_pattern)
| This method is deprecated; it completely replaces all the in patterns that have previously been set with the indicated pattern.
| setInPattern (string in_pattern)
| This method is deprecated; it completely replaces all the in patterns that have previously been set with the indicated pattern.
| setOutPattern (string out_pattern)
| This method is deprecated; it completely replaces all the in patterns that have previously been set with the indicated pattern.
## Static Public Member Functions
static TypeHandle | getClassType ()

## Detailed Description

A specialized kind of CollisionHandler that throws an event for each collision detected.

The event thrown may be based on the name of the moving object or the struck object, or both. The first parameter of the event will be a pointer to the CollisionEntry that triggered it.

## Constructor & Destructor Documentation

CollisionHandlerEvent | ( |  | ) |

The default CollisionHandlerEvent will throw no events.

Its pattern strings must first be set via a call to add_in_pattern() and/or add_out_pattern().

## Member Function Documentation

addAgainPattern | ( | string | again_pattern | ) |

Adds the pattern string that indicates how the event names are generated when a collision between two particular nodes is *still* detected.

This event is thrown each consecutive time a collision between two particular nodes is detected, starting with the second time.

In general, the in_pattern event is thrown on the first detection of a collision between two particular nodes. In subsequent passes, as long as a collision between those two nodes continues to be detected each frame, the again_pattern is thrown. The first frame in which the collision is no longer detected, the out_pattern event is thrown.

addInPattern | ( | string | in_pattern | ) |

Adds a pattern string to the list of events that will be generated in response to a collision.

The pattern string describes how the event name will be composed. It is a string that may contain any of the following:

fn - the name of the "from" object's node in - the name of the "into" object's node fs - 't' if "from" is tangible, 'i' if intangible is - 't' if "into" is tangible, 'i' if intangible ig - 'c' if the collision is into a CollisionNode, 'g' if it is a geom.

%(tag)fh - generate event only if "from" node has the indicated net tag. %(tag)fx - generate event only if "from" node does not have the indicated net tag. %(tag)ih - generate event only if "into" node has the indicated net tag. %(tag)ix - generate event only if "into" node does not have the indicated net tag. %(tag)ft - the indicated net tag value of the "from" node. %(tag)it - the indicated net tag value of the "into" node.

Parentheses in the above are literal and should be included in the actual pattern.

The event name will be based on the in_pattern string specified here, with all occurrences of the above strings replaced with the corresponding values.

In general, the in_pattern event is thrown on the first detection of a collision between two particular nodes. In subsequent passes, as long as a collision between those two nodes continues to be detected each frame, the again_pattern is thrown. The first frame in which the collision is no longer detected, the out_pattern event is thrown.

addOutPattern | ( | string | out_pattern | ) |

Adds the pattern string that indicates how the event names are generated when a collision between two particular nodes is *no longer* detected.

In general, the in_pattern event is thrown on the first detection of a collision between two particular nodes. In subsequent passes, as long as a collision between those two nodes continues to be detected each frame, the again_pattern is thrown. The first frame in which the collision is no longer detected, the out_pattern event is thrown.

clear | ( |  | ) |

Empties the list of elements that all colliders are known to be colliding with.

No "out" events will be thrown; if the same collision is detected next frame, a new "in" event will be thrown for each collision.

This can be called each frame to defeat the persistent "in" event mechanism, which prevents the same "in" event from being thrown repeatedly. However, also see add_again_pattern(), which can be used to set the event that is thrown when a collision is detected for two or more consecutive frames.

clearAgainPatterns | ( |  | ) |

Removes all of the previously-added in patterns.

See add_again_pattern.

clearInPatterns | ( |  | ) |

Removes all of the previously-added in patterns.

See add_in_pattern.

clearOutPatterns | ( |  | ) |

Removes all of the previously-added in patterns.

See add_out_pattern.

flush | ( |  | ) |

Same as clear() except "out" events are thrown.

string getAgainPattern | ( | int | n | ) |

Returns the nth pattern string that indicates how the event names are generated for each collision detected.

See add_again_pattern().

list getAgainPatterns | ( |  | ) |

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from CollisionHandler.

Reimplemented in CollisionHandlerPhysical, CollisionHandlerFloor, CollisionHandlerPusher, CollisionHandlerFluidPusher, CollisionHandlerGravity, and CollisionHandlerHighestEvent.

string getInPattern | ( | int | n | ) |

Returns the nth pattern string that indicates how the event names are generated for each collision detected.

See add_in_pattern().

list getInPatterns | ( |  | ) |

int getNumAgainPatterns | ( |  | ) |

Returns the number of in pattern strings that have been added.

int getNumInPatterns | ( |  | ) |

Returns the number of in pattern strings that have been added.

int getNumOutPatterns | ( |  | ) |

Returns the number of in pattern strings that have been added.

string getOutPattern | ( | int | n | ) |

Returns the nth pattern string that indicates how the event names are generated for each collision detected.

See add_out_pattern().

list getOutPatterns | ( |  | ) |

setAgainPattern | ( | string | again_pattern | ) |

This method is deprecated; it completely replaces all the in patterns that have previously been set with the indicated pattern.

setInPattern | ( | string | in_pattern | ) |

This method is deprecated; it completely replaces all the in patterns that have previously been set with the indicated pattern.

setOutPattern | ( | string | out_pattern | ) |

This method is deprecated; it completely replaces all the in patterns that have previously been set with the indicated pattern.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties